#version 420 core

layout(location = 0) in vec2 position;
layout(location = 1) in vec3 color;
layout(location = 2) in vec2 texture;

struct Light {
    vec3 position;
};  

out vec3 Color;

out vec2 texture_interpolated;

uniform mat4 view;
uniform mat4 proj;
uniform mat4 backgroundModel;

uniform Light lights[4];

out Light transformedLights[4];

out vec3 FragPos;

void main(){

texture_interpolated = texture;

// remove view * backgroundModel for static background

for(int i = 0; i < 4; i++){
vec4 clight = proj * view * vec4(lights[i].position, 1.0f);
transformedLights[i].position = clight.xyz/clight.w;
transformedLights[i].position.z = 0.1;
}

FragPos = vec3(position, 0.0f);

gl_Position = proj * view * backgroundModel * vec4(position, 0.0, 1.0);
Color = color;
}
